`timescale 1ns / 1ps
////////////////////////////////////////////////////////////////////////////////
// Engineer: Magnus Overbo
// 
// Create Date: 03/24/2019 12:22:01 PM
// Module Name: ram
// Revision		1.0 initial version
////////////////////////////////////////////////////////////////////////////////

module sram #(parameter ADDR_WIDTH=8, DATA_WIDTH=8, DEPTH=256) (
    input wire  clk,
    input wire  [ADDR_WIDTH-1:0] i_addr,
    input wire  i_write,
    input wire  [DATA_WIDTH-1:0] i_data,
    output reg  [DATA_WIDTH-1:0] o_data 
);
    
																							//Create RAM array
    reg [DATA_WIDTH-1:0] memory_array [0:DEPTH-1];
    
    always @(posedge clk) begin
        if( i_write ) begin										//Write data to memory
            memory_array[i_addr] <= i_data;		
        end
        else begin														//Store data to output reg
            o_data <= memory_array[i_addr];
        end
    end
    
endmodule
